"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _reduxQuery = require("redux-query");

var _context = _interopRequireDefault(require("../context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var useQueriesState = function useQueriesState(queryConfigs) {
  var contextValue = React.useContext(_context["default"]);

  if (!contextValue) {
    throw new Error("Could not find redux-query-react's context. Be sure to render a redux-query <Provider> near the root of your React tree.");
  }

  var queriesSelector = contextValue.queriesSelector;
  var isPending = (0, _reactRedux.useSelector)(function (state) {
    return queryConfigs.some(function (queryConfig) {
      return _reduxQuery.querySelectors.isPending(queriesSelector(state), queryConfig);
    });
  });
  var isFinished = (0, _reactRedux.useSelector)(function (state) {
    return queryConfigs.every(function (queryConfig) {
      return _reduxQuery.querySelectors.isFinished(queriesSelector(state), queryConfig);
    });
  });
  var queryState = React.useMemo(function () {
    return {
      isPending: isPending,
      isFinished: isFinished
    };
  }, [isFinished, isPending]);
  return queryState;
};

var _default = useQueriesState;
exports["default"] = _default;